Subject: Re: bug#45799: 28.0.50; Faces shrink unreadable on GUI when foreground/background color set in TUI

From: Jean Louis <[email-masked]>
Date: Tue, 12 Jan 2021 20:55:02 +0300

* Eli Zaretskii <[email-masked]> [2021-01-12 20:11]:
> > Date: Tue, 12 Jan 2021 19:36:57 +0300
> > From: Jean Louis <[email-masked]>
> > Cc: [email-masked]
> > 
> > > This is a whole different problem, one that I cannot reproduce.  For
> > > me, customize-themes works as documented: I can enable and disable any
> > > theme I want, and it works as I'd expect, including changes in colors.
> > > 
> > > However, you didn't tell how you used customize-themes, and what
> > > didn't work there, so I don't think we are talking about the same
> > > thing.
> > 
> > I have given the recipe how to reproduce. You say you cannot reproduce
> > it?
> 
> You didn't give the recipe for using customize-themes which you say
> doesn't work unless you unset the colors.  That was the reason you
> needed to unset the colors to begin with, right?  Or did I
> misunderstand you?

That was the reason. But not a problem described.

> Once again: unsetting colors as you did will affect the default face
> on all frames, which is not what you want.

Ideally I would like if I unset colors in console or GUI, that it
affects all frames. Not one frame.

I could see you have idea of setting up one frame, but that was never
my idea, and I never yet desired to do so. Just to inform you of
user's pattern of thinking.

> So if you really need ti change the default colors, I suggest using
> set-face-foreground and set-face-background, which can be told to
> change the colors only for a certain frame.

That is alright as workaround and it solves temporarily some
problems. But doing that is difficult as on console some letters will
disappear, one has to do blind job.

set-foreground-color white will whiten many things and then I have to
do blind set-background-color black. With "blind" I mean that many
letters I will not be able to read as some have been already set white.

> And if you don't need to change the colors, but need
> customize-themes to work, then let's talk about your problem with
> customize-themes, and forget about changing the default face, which
> you say was just a workaround.

I prefer quickly changing a theme rather then foreground/background
one by one. But I reported bug for other users more than for me
personally. 

> > > It's not a bug, it's a cockpit error: you yourself did something that
> > > has this effect, and you did it globally.  Customize is limited to
> > > changing faces globally, on all frames, existing and future ones; if
> > > that's not what you want, don't use Customize.
> > 
> > So you say if I unset foreground color by using emacsclient in
> > console, it is just fine that all the fonts in GUI are shrinked?
> 
> You didn't unset the colors, you've customized the default face.

Yes, I see.

But if default face on GUI 113 and on TUI 1, then user shall not get 1
on TUI to customize also GUI to be 1. Can we agree on that?

In my opinion if Emacs strategy on console is to display console's
font's size then better affect only console even if there is no real
effect, rather that then affecting the GUI and shrinking fonts to 1.

> > I did not shrink the faces and I did not unset settings of fonts. Why
> > is then font changing? It is not logical to say that should be default
> > behavior.
> 
> You are using Customize for a job for which it wasn't intended.  Font
> size problems aside, using Customize like that will never do what you
> want.  Why do you insist on using a command for a job that is not what
> you want?

I do not insist, I use what I think I have as an option to use. If I
wish to change the theme I cannot change it because foreground and
background colors first need to be unset, you say customize, but for
me it is unsetting as I remove the [X] into empty [ ] and apply it for
current session, only then I can customize the theme.

By attempting to do so, faces shrunk and I did not know it is because
of font being 1 pt.

With emacs -Q I cannot reproduce the theme settings. Problem is
appearing when user has already set the foreground and background
colors as then themes will not change those colors.

Is that maybe default behavior?